/*
BTCL - Copyright (C) 2001, 2002
by Andrea Marchesini
a.marchesini@ngi.it

OTHER.C
*/

#include <string.h>
#include "btcl.h"


/* Cgi_get: explore e decode_hex di un var(QUERY_STRINGS) */
int cgi_get(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[]) {
 static char tmp[MAX_STR], var_tmp[MAX_STR], nvar_tmp[MAX_STR];
 static char vvar_tmp[MAX_STR];
 char c,f;
 int a,b,d,e;

 switch(argc) {
  case 1:
   if(Tcl_GetVar(interp,"env(QUERY_STRING)",1)!=NULL)
    strcpy(tmp,Tcl_GetVar(interp,"env(QUERY_STRING)",1));
   else {
    Tcl_SetResult (interp, "-1", TCL_VOLATILE);
    return TCL_OK;
   }
   break;
  case 2: 
   strcpy(tmp,argv[1]);
   break;
  default: 
   puts("Error: wrong args: should be \"cgi_get ?VarName?\"");
   return TCL_ERROR;
   break;
 }
   
 if(strlen(tmp)==0) {
  Tcl_SetResult (interp, "-1", TCL_VOLATILE);
  return TCL_OK;
 }

 strcat(tmp,"&");
   
 /* Decodifico: */
 for(a=0,b=0,c=0;a<strlen(tmp);a++,b++) {
  if(tmp[a]=='=') {
   nvar_tmp[b]=0;
   c=1;
   b=-1;
   for(d=0,e=0,f=0;d<strlen(nvar_tmp);d++,e++) {
    if(nvar_tmp[d]=='%') {
     if(nvar_tmp[++d]>47 && nvar_tmp[d]<58) f=(nvar_tmp[d]-48)*16;
     else if(nvar_tmp[d]>64 && nvar_tmp[d]<71) f=(nvar_tmp[d]-55)*16;
     else if(nvar_tmp[d]>96 && nvar_tmp[d]<103) f=(nvar_tmp[d]-87)*16;
     if(nvar_tmp[++d]>47 && nvar_tmp[d]<58) f+=nvar_tmp[d]-48;
     else if(nvar_tmp[d]>64 && nvar_tmp[d]<71) f+=nvar_tmp[d]-55;
     else if(nvar_tmp[d]>96 && nvar_tmp[d]<103) f+=nvar_tmp[d]-87;
     var_tmp[e]=f;
    } else if(nvar_tmp[d]=='+') var_tmp[e]=' ';
    else var_tmp[e]=nvar_tmp[d];
   }
   var_tmp[e]=0;
  } else if(tmp[a]=='&') {
   vvar_tmp[b]=0;
   for(d=0,e=0,f=0;d<strlen(vvar_tmp);d++,e++) {
    if(vvar_tmp[d]=='%') {
     if(vvar_tmp[++d]>47 && vvar_tmp[d]<58) f=(vvar_tmp[d]-48)*16;
     else if(vvar_tmp[d]>64 && vvar_tmp[d]<71) f=(vvar_tmp[d]-55)*16;
     else if(vvar_tmp[d]>96 && vvar_tmp[d]<103) f=(vvar_tmp[d]-87)*16;
     if(vvar_tmp[++d]>47 && vvar_tmp[d]<58) f+=vvar_tmp[d]-48;
     else if(vvar_tmp[d]>64 && vvar_tmp[d]<71) f+=vvar_tmp[d]-55;
     else if(vvar_tmp[d]>96 && vvar_tmp[d]<103) f+=vvar_tmp[d]-87;
     nvar_tmp[e]=f;
    } else if(vvar_tmp[d]=='+') nvar_tmp[e]=' ';
    else nvar_tmp[e]=vvar_tmp[d];
   }
   nvar_tmp[e]=0;
   Tcl_SetVar(interp,var_tmp,nvar_tmp,1);
   c=0;
   b=-1;
  } else if(c==0) nvar_tmp[b]=tmp[a];     
  else vvar_tmp[b]=tmp[a];
 }
 vvar_tmp[b]=0;
 Tcl_SetVar(interp,nvar_tmp,vvar_tmp,1);
 Tcl_SetResult (interp, "0", TCL_VOLATILE);
 return TCL_OK;
}

/* Fa explode e decode_hex in modo furbo: */
int cgi_post(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
             {
 int a,b,d,e;
 static char var_tmp[MAX_STR], nvar_tmp[MAX_STR], vvar_tmp[MAX_STR];
 static char tmp[MAX_STR];
 char c,f;

 if(argc==1) {
  scanf("%s",tmp);
  Tcl_SetVar(interp,"input_cgi_post",tmp,0);
 } else if(argc==2) for(a=0;a<strlen(argv[1]);a++) tmp[a]=argv[1][a];
 else {
  puts("Error: wrong args: should be \"cgi_post varName\"");
  return TCL_ERROR;
 }
 strcat(tmp,"&");

 /* Decodifico: */
 for(a=0,b=0,c=0;a<strlen(tmp);a++,b++) {
  if(tmp[a]=='=') {
   nvar_tmp[b]=0;
   c=1;
   b=-1;
   for(d=0,e=0,f=0;d<strlen(nvar_tmp);d++,e++) {
    if(nvar_tmp[d]=='%') {
     if(nvar_tmp[++d]>47 && nvar_tmp[d]<58) f=(nvar_tmp[d]-48)*16;
     else if(nvar_tmp[d]>64 && nvar_tmp[d]<71) f=(nvar_tmp[d]-55)*16;
     else if(nvar_tmp[d]>96 && nvar_tmp[d]<103) f=(nvar_tmp[d]-87)*16;
     if(nvar_tmp[++d]>47 && nvar_tmp[d]<58) f+=nvar_tmp[d]-48;
     else if(nvar_tmp[d]>64 && nvar_tmp[d]<71) f+=nvar_tmp[d]-55;
     else if(nvar_tmp[d]>96 && nvar_tmp[d]<103) f+=nvar_tmp[d]-87;
     var_tmp[e]=f;
    } else if(nvar_tmp[d]=='+') var_tmp[e]=' ';
    else var_tmp[e]=nvar_tmp[d];
   }
   var_tmp[e]=0;
  } else if(tmp[a]=='&') {
   vvar_tmp[b]=0;
   for(d=0,e=0,f=0;d<strlen(vvar_tmp);d++,e++) {
    if(vvar_tmp[d]=='%') {
     if(vvar_tmp[++d]>47 && vvar_tmp[d]<58) f=(vvar_tmp[d]-48)*16;
     else if(vvar_tmp[d]>64 && vvar_tmp[d]<71) f=(vvar_tmp[d]-55)*16;
     else if(vvar_tmp[d]>96 && vvar_tmp[d]<103) f=(vvar_tmp[d]-87)*16;
     if(vvar_tmp[++d]>47 && vvar_tmp[d]<58) f+=vvar_tmp[d]-48;
     else if(vvar_tmp[d]>64 && vvar_tmp[d]<71) f+=vvar_tmp[d]-55;
     else if(vvar_tmp[d]>96 && vvar_tmp[d]<103) f+=vvar_tmp[d]-87;
     nvar_tmp[e]=f;
    } else if(vvar_tmp[d]=='+') nvar_tmp[e]=' ';
    else nvar_tmp[e]=vvar_tmp[d];
   }
   nvar_tmp[e]=0;
   Tcl_SetVar(interp,var_tmp,nvar_tmp,1);
   c=0;
   b=-1;
  } else if(c==0) nvar_tmp[b]=tmp[a];
  else vvar_tmp[b]=tmp[a];
 }
 vvar_tmp[b]=0;
 Tcl_SetVar(interp,nvar_tmp,vvar_tmp,1);
 Tcl_SetResult (interp, "0", TCL_VOLATILE);
 return TCL_OK;
}

/* Decoder of a string in hex format: */
int decode_hex(ClientData clientData, Tcl_Interp *interp, int argc, 
               char *argv[]) {
 int a,b,c;
 char var_tmp[MAX_STR];

 if(argc!=2) {
  puts("Error: wrong args: should be \"decode_hex varName\"");
  return TCL_ERROR;
 }

 /* Decodifico: */
 for(a=0,b=0,c=0;a<strlen(argv[1]);a++,b++) {
  if(argv[1][a]=='%') {
   if(argv[1][++a]>47 && argv[1][a]<58) c=(argv[1][a]-48)*16;
   else if(argv[1][a]>64 && argv[1][a]<71) c=(argv[1][a]-55)*16;
   else if(argv[1][a]>96 && argv[1][a]<103) c=(argv[1][a]-87)*16;
   if(argv[1][++a]>47 && argv[1][a]<58) c+=argv[1][a]-48;
   else if(argv[1][a]>64 && argv[1][a]<71) c+=argv[1][a]-55;
   else if(argv[1][a]>96 && argv[1][a]<103) c+=argv[1][a]-87;
   var_tmp[b]=c;
  } else if(argv[1][a]=='+') var_tmp[b]=' ';
  else var_tmp[b]=argv[1][a];
 }
 var_tmp[b]=0;
 Tcl_SetResult (interp, var_tmp, TCL_VOLATILE);
 return TCL_OK; 
}


/* explode a variable POST for internet:
 * Data il post di un form html (ciao=23&mamma=34da&ad) divide le variabili =)
 */
int explode(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]) 
            {
 int a,b,c;
 static char nvar_tmp[MAX_STR], vvar_tmp[MAX_STR];
 if(argc!=2) {
  puts("Error: wrong args: should be \"explode varName\"");
  return TCL_ERROR;
 }
 for(a=0,b=0,c=0;a<strlen(argv[1]);a++,b++) {
  if(argv[1][a]=='=') {
   nvar_tmp[b]=0;
   c=1;
   b=-1;
  } else if(argv[1][a]=='&') {
   vvar_tmp[b]=0;
   Tcl_SetVar(interp,nvar_tmp,vvar_tmp,1);
   c=0;
   b=-1;
  } else if(c==0) nvar_tmp[b]=argv[1][a];     
  else vvar_tmp[b]=argv[1][a];
 }
 vvar_tmp[b]=0;

 Tcl_SetVar(interp,nvar_tmp,vvar_tmp,1);
 return TCL_OK;
}

/* Coder of a string in hex format: */
int code_hex(ClientData clientData, Tcl_Interp *interp, int argc, 
               char *argv[]) {
 int a,b;
 char var_tmp[MAX_STR],tmp[4];

 if(argc!=2) {
  puts("Error: wrong args: should be \"code_hex varName\"");
  return TCL_ERROR;
 }

 for(a=b=0;a<strlen(argv[1]);a++) {
  if((unsigned char)argv[1][a]<10) sprintf(tmp,"00%d",(unsigned char)argv[1][a]);
  else if((unsigned char)argv[1][a]<100) sprintf(tmp,"0%d",(unsigned char)argv[1][a]);
  else sprintf(tmp,"%d",(unsigned char)argv[1][a]);
  var_tmp[b++]='&';
  var_tmp[b++]='#';
  var_tmp[b++]=tmp[0];
  var_tmp[b++]=tmp[1];
  var_tmp[b++]=tmp[2];
  var_tmp[b++]=';';
 }
 var_tmp[b]=0;
 Tcl_SetResult (interp, var_tmp, TCL_VOLATILE);
 return TCL_OK; 
}


